# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# MCT - Mini Cliente Torrent para pelisalacarta
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os
import sys

import time
import libtorrent as lt

import xbmc
import xbmcgui

from platformcode.xbmc import xbmctools
from platformcode.xbmc import library

from core import scrapertools
from core import config
from core import logger
from core.item import Item

def play(url, is_view=None):

    if not url.endswith(".torrent") and not url.startswith("magnet"):
        t_file = scrapertools.get_header_from_response(url,header_to_get="location")
        if len(t_file) > 0:
            url = t_file

    # -- Crear dos carpetas en descargas para los archivos ------
    save_path_videos = os.path.join( config.get_setting("downloadpath") , "torrent-videos" )
    save_path_torrents = os.path.join( config.get_setting("downloadpath") , "torrent-torrents" )
    if not os.path.exists( save_path_torrents ): os.mkdir(save_path_torrents)
    # -----------------------------------------------------------

    # -- Usar - archivo torrent desde web, meagnet o HD ---------
    if not os.path.isfile(url) and not url.startswith("magnet"):
        # -- http - crear archivo torrent -----------------------
        data = url_get(url)

        # -- El nombre del torrent será el que contiene en los --
        # -- datos.                                             -
        re_name_len = int( scrapertools.get_match(data,':name(\d+):') )
        re_name = library.title_to_folder_name( urllib.unquote( scrapertools.get_match(data,':name\d+:([^:]+):') ) )
        torrent_file = os.path.join(save_path_torrents, re_name[:(re_name_len-1)]+'.torrent')

        f = open(torrent_file,'wb')
        f.write(data)
        f.close()
    elif os.path.isfile(url):
        # -- file - para usar torrens desde el HD ---------------
        torrent_file = url
    else:
        # -- magnet - crearar torrent desde magnet - Pendiente --
        # -- Se intenterá crear un .torrent para mejorar la     -
        # -- descarga.                                          -
        torrent_file = url
    # -----------------------------------------------------------

    # -----------------------------------------------------------
    # -- MCT - MiniClienteTorrent -------------------------------
    # -----------------------------------------------------------
    ses = lt.session()
    ses.listen_on(6881, 6891)

    video_file = ""
    if not torrent_file.startswith("magnet"):
        # -- Archivos torrent -----------------------------------
        info = lt.torrent_info(torrent_file)

        # -- El más gordo se entiende que es el vídeo -----------
        size_file = 0
        for f in info.files():
            if f.size > size_file:
                video_file = f.path.replace("\\","/")
                size_file = f.size
        # -------------------------------------------------------
        h = ses.add_torrent( { 'ti':info, 'save_path': save_path_videos, 'storage_mode':lt.storage_mode_t.storage_mode_allocate } )
        # -------------------------------------------------------
    else:
        # -- Enlaces magnet -------------------------------------
        # -- Se intentará quitar esta opción. Si se crea un     -
        # -- .torrent con el magnet, la descarga será mucho más -
        # -- rápida                                             -
        h = ses.add_torrent( { 'url':torrent_file, 'save_path': save_path_videos, 'storage_mode':lt.storage_mode_t.storage_mode_allocate } )
        # -------------------------------------------------------
    # -----------------------------------------------------------

    # -- Descarga secuencial - trozo 1, trozo 2, ... ------------
    h.set_sequential_download(True)

    dp = xbmcgui.DialogProgress()
    dp.create('pelissalacarta-MCT')

    while (not h.is_seed()):

        s = h.status()

        state_str = ['queued', 'checking', 'downloading metadata', \
            'downloading', 'finished', 'seeding', 'allocating', 'checking fastresume']

        message = '%.2f%% d:%.1f kb/s u:%.1f kB/s p:%d s:%d %s' % \
            (s.progress * 100, s.download_rate / 1000, s.upload_rate / 1000, \
            s.num_peers, s.num_seeds, state_str[s.state])
        porcent = int( s.progress * 100 )

        if "/" in video_file: video_file.split("/")[1]
        msg_file = video_file + " (%.2f)" % (s.total_wanted/1048576.0)

        print message

        # -- play video -----------------------------------------
        if porcent >= 5 and is_view != "Ok" and s.state == 3:
            is_view = "Ok"
            dp.close()
            # ---------------------------------------------------
            playlist = xbmc.PlayList( xbmc.PLAYLIST_VIDEO )
            playlist.clear()
            playlist.add( os.path.join( save_path_videos, video_file ) )
            player = xbmc.Player()
            player.play( playlist)
            # ---------------------------------------------------
        # -------------------------------------------------------

        if is_view == "Ok" and not xbmc.Player().isPlaying():
            dp.close()
            return []
        if is_view != "Ok" :
            dp.update(porcent, message, msg_file)

        if dp.iscanceled():
            dp.close()
            return []
        # -------------------------------------------------------
    if is_view == "Ok" and not xbmc.Player().isPlaying():
        return []

    d = xbmcgui.Dialog()
    ok= d.ok ('pelissalacarta-MCT', video_file, 'Descarga completada')

    return []
# ---------------------------------------------------------------

# -- Preguntar si se desea borrar el torrent y el vídeo ---------
# -- Pendiente                                                  -
def remove_files(video_folder, video_file, torrent_file):

    d = xbmcgui.Dialog()
    ok= d.yesno('pelissalacarta-MCT', video_file, 'Borrar torrent y video')

    # -- SI -----------------------------------------------------
    if ok:
        # -- Borrar archivos - vídeos ---------------------------
        if os.path.isfile(video_file):
            space_for_indent = ""
        # -- Borrar archivo - torrent ---------------------------
        if os.path.isfile(torrent_file):
            space_for_indent = ""
        # -- Borrar carpeta - vídeo -----------------------------
        if os.path.exists(video_folder):
            space_for_indent = ""
    # -----------------------------------------------------------

    return
# ---------------------------------------------------------------

# -- Descargar de la web los datos para crear el torrent --------
def url_get(url, params={}, headers={}):
    from contextlib import closing

    USER_AGENT = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.8; rv:20.0) Gecko/20100101 Firefox/20.0"

    if params:
        import urllib
        url = "%s?%s" % (url, urllib.urlencode(params))

    req = urllib2.Request(url)
    req.add_header("User-Agent", USER_AGENT)
    for k, v in headers.items():
        req.add_header(k, v)

    try:
        with closing(urllib2.urlopen(req)) as response:
            data = response.read()
            if response.headers.get("Content-Encoding", "") == "gzip":
                import zlib
                return zlib.decompressobj(16 + zlib.MAX_WBITS).decompress(data)
            return data
    except urllib2.HTTPError:
        return None
# ---------------------------------------------------------------
